package link.RottenFleshChangeLeather;

import java.util.*;
import cpw.mods.fml.common.Mod.*;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;

import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;

import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.EntityRegistry;
import cpw.mods.fml.common.IFuelHandler;
import cpw.mods.fml.client.registry.RenderingRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

import net.minecraftforge.common.util.EnumHelper;
import net.minecraftforge.common.BiomeManager;
import net.minecraft.util.IIcon;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.block.Block;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemArmor.ArmorMaterial;
import net.minecraft.item.Item.ToolMaterial;
import net.minecraft.item.ItemStack;
import net.minecraft.entity.Entity;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.world.biome.BiomeGenBase;
import net.minecraft.entity.EnumCreatureType;

import net.minecraftforge.common.MinecraftForge;
import java.lang.reflect.*;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import net.minecraft.world.gen.layer.*;
import net.minecraftforge.event.terraingen.WorldTypeEvent;
@Mod(modid="RottenFleshChangeLeather", name="RottenFleshChangeLeather", version="ModMaker v0.151")
public class RottenFleshChangeLeather {

	@Instance(value="RottenFleshChangeLeather")
	public static RottenFleshChangeLeather instance;
	EventManager eventManager = new EventManager();
	public static final String MODID = "RottenFleshChangeLeather";
	@SidedProxy(clientSide="link.RottenFleshChangeLeather.client.ClientProxy", serverSide="link.RottenFleshChangeLeather.CommonProxy")
	public static CommonProxy proxy;

	@Mod.EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		proxy.registerRenderInformation();
		MinecraftForge.TERRAIN_GEN_BUS.register(this);
	}
	@Mod.EventHandler
	public void init(FMLInitializationEvent event) {
		GameRegistry.registerFuelHandler(new FuelHandler());
		GameRegistry.registerWorldGenerator(eventManager, 12);
		GameRegistry.addSmelting(new ItemStack(Items.field_151078_bh, 1, 0), new ItemStack(Items.field_151116_aA, 1, 0), 0.1F);
	}
	@Mod.EventHandler
	public void postInit(FMLPostInitializationEvent event) {}
	private static Field biomePatternGeneratorChainField;
	private static Field biomeArrayField;

	static {
		try {
			biomePatternGeneratorChainField = GenLayerRiverMix.class.getDeclaredField("field_75910_b");
			biomePatternGeneratorChainField.setAccessible(true);
			biomeArrayField = GenLayerBiome.class.getDeclaredField("field_151621_d");
			biomeArrayField.setAccessible(true);
		} catch (NoSuchFieldException e) {
			e.printStackTrace();
		}
	}

	@SubscribeEvent
	public void onGenLayerInit(WorldTypeEvent.InitBiomeGens event) throws IllegalAccessException {
		GenLayer biomeLayer = event.originalBiomeGens[1];
		do {
			if (biomeLayer instanceof GenLayerRiverMix) {
				biomeLayer = (GenLayer) biomePatternGeneratorChainField.get(biomeLayer);
			} else {
				biomeLayer = RottenFleshChangeLeatherLayerAccessor.getParent(biomeLayer);
			}
		} while (biomeLayer != null && !(biomeLayer instanceof GenLayerBiome));
		if (biomeLayer == null)
			throw new IllegalStateException("Couldn't locate GenLayerBiome");
		BiomeGenBase[] biomes = (BiomeGenBase[]) biomeArrayField.get(biomeLayer);
		BiomeGenBase[] newBiomes = new BiomeGenBase[biomes.length + 0];
		for (int i = 0; i < biomes.length; i++)
			newBiomes[i] = biomes[i];
		biomeArrayField.set(biomeLayer, newBiomes);
	}
	public class FuelHandler implements IFuelHandler {
		public int getBurnTime(ItemStack fuel) {
			return 0;
		}
	}
}